print macro string
   lea dx, string
   mov  ah,9
   int  21h
   endm
buffersize=8000h
buffermax = 24
cseg segment 'CODE'
   assume cs:cseg,ds:cseg
   org  100h
entry: jmp start
; data
istack db 'GLIST text lister',13,10
       db 'Copyright 1991 by Keith P. Graham',13,10,'$'
error1 db 'Invalid file name or file not found.',13,10,'$'
error2 db 'Error Allocating Memory',13,10,'$'
error3 db 'Error Reading File',13,10,'$'
cursor  dw 0
handle  dw 0
buffcount  dw  0
buffers dw buffermax*2 dup(0)
        dw 0,0,0,0
file_size dw 0,0
color     db  17h
color1    db  17h
; vwid and vlen are the size of the current panel
vwid      dw  80
vlen      dw  23  ; virtual length of page
; ux and uy are the screen cordinates of the first print area
ux        db  0
uy        db  1
; x and y are the current location?
x         db  0
y         db  0   ; screen line number
curline   dw  0,0
topline   dw  0,0
bot_line db 'Esc=Quit,P=Print,F=Find,C=Cont,Keys=Pgup,PgDn,Home,End,,'
         db '          Line='
lineno   db '0000',0
bline    dw 0
top_line db 'GLIST v2.1 - '
infile  db 64 dup(0)
vbuff     dw  0b800h
mode      db  0
;
; old params
curr_line dw  0   ; current line number
line_count dw 0
line_no   dw  0
;
;
error_cond:
     call showcurs
     call unallocate
     int 20h
start:
     call  hidecurs
     mov   bline,0
     call  getmode      ; get video segment,etc
     call parse_line    ; gets filename off of command line
     jc   error_cond
     call open_file     ; opens input file
     jc   error_cond
     call  memory_alloc ; shrinks and allocates the file buffer
     jc   error_cond
     call  read_file    ; reads file (up to 64k) into buffer
     jc   error_cond
     mov   curline,0
     mov   curline+2,0
     mov   topline,0
     mov   topline+2,0
     mov   ah,ux
     mov   x,ah
     mov   ah,uy
     mov   y,ah
     call  setup_screen
     jmp   dloop
error_loop:

     jmp   dloop2
;
dloop:
     call  do_line_no
     call  display_page ; show a page
dloop2:
      mov   ah,0
      int    16h        ; wait for key
; first the function stuff
      cmp   ah,47h
      jl    do_letters
      cmp   ah,51h
      jg    do_letters
      mov   bl,ah
      mov   bh,0
      sub   bx,47h
      shl   bx,1
      jmp   cs:kkeys[bx]
do_letters:
      cmp   al,'a'
      jl   is_upper
      cmp   al,'z'
      jg   is_upper
      sub   al,20h
is_upper:
      cmp   al,'P'
      je    printf
      cmp   al,'C'
      je    fcont
      cmp   al,'F'
      je    find
      cmp   al,27
      jne   error_loop
end_prog:
     call showcurs
     call unallocate
     int 20h
printf:
     jmp   printit
fcont:
     jmp   findmore
find:
     jmp   findit
printit:
; this prints the whole document
;
     mov    curline,0
     mov    curline+2,0
print_loop:
     call   get_byte
     jc     done_print
     call   print_byte
     jnc    print_loop
done_print:
;
     jmp    dloop
print_byte:
; get the printer status first
     push   ax
     mov    ah,1
     mov    dx,0
     int    17h
     and    ah,29h
     cmp    ah,0
     jne    bad_print
     pop    ax
     mov    ah,0
     mov    dx,0
     int    17h
     clc
     ret
bad_print:
     pop    ax
     stc
     ret
findmore:
findit:
    jmp   error_loop
down:
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
      call find_next
     mov    ax,curline
     mov    topline,ax
     mov    ax,curline+2
     mov    topline+2,ax
      jmp  dloop
up:
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
      call find_prev
     mov    ax,curline
     mov    topline,ax
     mov    ax,curline+2
     mov    topline+2,ax
      jmp  dloop
pgdn:
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
     mov  cx,23
pd_loop:
     push  cx
      call find_next
     pop   cx
     loop  pd_loop
     mov    ax,curline
     mov    topline,ax
     mov    ax,curline+2
     mov    topline+2,ax
      jmp  dloop
pgup:
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
     mov  cx,23
pu_loop:
     push  cx
      call find_prev
     pop   cx
     loop  pu_loop
     mov    ax,curline
     mov    topline,ax
     mov    ax,curline+2
     mov    topline+2,ax
      jmp  dloop
home:
      mov  topline,0
      mov  topline+2,0
      mov  bline,0
      jmp  dloop
endk:
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
endk1:
      call find_next
      jnc  endk1
     mov    ax,curline
     mov    topline,ax
     mov    ax,curline+2
     mov    topline+2,ax
      jmp  pgup
kkeys dw home,up,pgup
      dw 5 dup(error_loop)
      dw endk,down,pgdn
check_line:
; checks the line number for validity
      cmp  curr_line,0
      jl   home
      mov  ax,line_count
      sub  ax,vlen
      cmp  curr_line,ax
      jg   endk
      jmp   dloop2
;
do_line_no:
; do the line number
     mov  ax,bline
     inc  ax
     mov  cx,100
     mov  dx,0
     div  cx
     mov  cl,10
     div  cl
     or   ax,3030h
     mov  di,offset lineno
     stosw
     mov  ax,dx
     div  cl
     or   ax,3030h
     stosw
     ret
;
unallocate:
     mov  di,0
una_loop:
     mov  dx,buffers[di]
     cmp  dx,0
     je   done_un
     push di
     push es
     mov  es,dx
     mov  ah,49h
     int  21h
     pop  es
     pop  di
     jc   done_un
     mov  ah,48h
     mov  bx,(buffersize+15)/16
     int  21h
     add  di,4
     jmp  una_loop
done_un:
     ret
;
get_byte:
; current byte is in currline
         push bx
         push dx
         push si
         push bp
         mov  bx,curline ; segment number of current line
         mov  si,curline+2
         shl  bx,1
         shl  bx,1
         mov  bp,buffers[bx]
         mov  dx,buffers[bx]+2
         cmp  bp,0
         je   gb_done
         cmp  dx,0
         je   gb_done
; get the byte
         push ds
         mov  ds,bp
         cld
         lodsb
         pop  ds
;        cmp  al,26
;        je   gb_done
         mov  curline+2,si
         cmp  dx,si
         ja   gb_exit
; get next segment
         mov  curline+2,0
         inc  curline
         cmp  buffers[bx]+4,0
         je   gb_done
gb_exit:
         pop  bp
         pop  si
         pop  dx
         pop  bx
         clc
         ret
gb_done:
         pop  bp
         pop  si
         pop  dx
         pop  bx
         stc
         ret
;
;
get_prev:
; this gets the next byte from the buffers
; current byte is in currline
         push bx
         push dx
         push si
         push bp
gp_0:
         mov  bx,curline ; segment number of current line
         cmp  bx,0
         jl   gp_done
         mov  si,curline+2
         shl  bx,1
         shl  bx,1
         mov  bp,buffers[bx]
; we are going backwards
         cmp  si,0
         jne  gp_2
         cmp   bx,0
         je   gp_done
         jmp  gp_1
gp_done:
         pop  bp
         pop  si
         pop  dx
         pop  bx
         stc
         ret
gp_1:
; need to back up a segment
         dec   curline
         sub   bx,4
         mov  bp,buffers[bx]
         mov  dx,buffers[bx]+2
         mov  si,dx
;
gp_2:
; get the byte
         dec  si
         mov  curline+2,si
; get the byte
         push ds
         mov  ds,bp
         cld
         lodsb
         pop  ds
gp_exit:
         pop  bp
         pop  si
         pop  dx
         pop  bx
         clc
         ret
;
;
find_next:
; advances one line
;
;    find out if we are already at the end of the line
; search for next 10
     call  get_byte
     jc    done_next
     inc   bline
next10:
     cmp   al,10
     je   done_next1
     call  get_byte
     jc    done_next
     jmp  next10
done_next1:
     clc
     ret
done_next:
     stc
     ret
;
;
;
;
find_prev:
; goes back
     call  get_prev ; passed the current 10
     jnc   prev10
     stc
     ret
;
; search for prev 10
prev10:
     call  get_prev
     jc    done_prev2
     cmp   al,10
     jne  prev10
done_prev:
     call  get_byte ; past the 10
done_prev2:
     dec   bline
     ret
;
read_file:
; get the file into memory
; this works byt allocatting an array of pointers
     mov   di,0
     mov   cx,buffermax
     mov   buffcount,0
     mov   file_size,0
     mov   file_size+2,0
rf_loop:
     push  cx
     push  di
; allocate 32k buffer for file access
     mov  ah,48h
     mov  bx,(buffersize+15)/16
     int  21h
     jc   done_read
     pop  di
     push di
     mov  buffers[di],ax
     push  ds
     mov   bx,handle
     mov   dx,0
     mov   cx,buffersize
     mov   ds,ax
     mov    ah,3fh
     int    21h
     pop    ds
     jc     bad_read1
     cmp    ax,0
     je    done_read
     pop   di
     mov   buffers[di]+2,ax
     inc   buffcount
     add   file_size,ax
     adc   file_size+2,0
     add   di,4
     pop   cx
     loop  rf_loop
     clc
     ret
done_read:
; finished file read
     pop   di
     pop   cx
     cmp   file_size,0
     jne   good_f
     cmp   file_size+2,0
     je    bad_read
good_f:
     cmp   buffcount,0
     je    bad_read
      clc
      ret
bad_read1:
     pop   di
     pop   cx
bad_read:
     print error3
     stc
     ret
;
display_page:
      mov      si,offset top_line
      mov      di,0
      call     printat
      mov      si,offset bot_line
      mov      di,24*80*2
      call     printat
; does the current page
     mov    ax,topline
     mov    curline,ax
     mov    ax,topline+2
     mov    curline+2,ax
     mov   ah,ux
     mov   x,ah
     mov   ah,uy
     mov   y,ah
     mov    cx,vlen
dp_loop:
     push  cx
     call  display_line
     inc   y
     pop   cx
     loop  dp_loop
     ret
;
;
display_line:
; this displays a line.
; curline has the line start in file
; topline has the page start in file
; x and y are current print location
;
; now where to put it
         mov  al,y
         mov  cl,160
         mul  cl
         mov  di,ax
         mov  al,x
         mov  ah,0
         shl  ax,1
         add  di,ax
         mov  cx,vwid
         mov   ah,color
; put the info to screen
         push  es
;
         mov   es,vbuff
dl_loop:
; check for segmentness
         call  get_byte
         jc    done_text
         cmp   al,13
         je    dl_loop
         cmp   al,10
         je    done_text
         stosb
         inc   di
         loop  dl_loop
         jmp   done_line
done_text:
         mov   al,20h
         stosb
         inc  di
         loop  done_text
;
done_line:
         pop   es
         ret
;
;
; service routines
;
clearscr:
      mov      ah,7
      mov      al,0
      mov      bh,color1
      mov      bl,0
      mov      cx,0
      mov      dx,004fh
      int      10h
      mov      ah,7
      mov      al,0
      mov      bh,color1
      mov      bl,0
      mov      cx,1800h
      mov      dx,184fh
      int      10h
      mov      ah,7
      mov      al,0
      mov      bh,color
      mov      bl,0
      mov      cx,0100h
      mov      dx,174fh
      int      10h
      ret
setup_screen:
      call     clearscr
      mov      si,offset top_line
      mov      di,0
      call     printat
      mov      si,offset bot_line
      mov      di,24*80*2
      call     printat
      ret
printat:
; si points to string, di points to video
      push   es
      mov    es,vbuff
pa_loop:
      cld
      lodsb
      cmp    al,0
      je     exit_pa
      stosb
      inc    di
      jmp    pa_loop
exit_pa:
      pop    es
      ret
getmode:
      mov    color,1fh
      mov    color1,70h
      mov     ah,15h
      int     10h
      mov     mode,al
      mov     vbuff,0b800h
      cmp     al,7
      je      mono
      ret
mono:
      mov    vbuff,0b000h
      mov    color,7fh
      mov    color,0F7h
      ret
showcurs:
      mov      ah,7
      mov      bh,17h
      mov      al,0
      mov      bl,0
      mov      cx,1800h
      mov      dx,184fh
      int      10h
          mov ah,2
          mov  dh,24
          mov  dl,0
          mov bx,0
          int  10h
;         mov  ah,14
;         mov  al,13
;         int  10h
;         mov  ah,14
;         mov  al,10
;         int  10h
          ret
hidecurs:
; set the cursor to a position off the screen
          mov  ah,2
          mov  bx,0
          mov  ch,25
          mov  cl,0
          mov  dh,25
          mov  dl,0
          int  10h
          ret

last_byte equ this byte
memory_alloc:
; allocates memory
; shrink
;
     mov  ah,4ah
     lea  bx,last_byte
     add  bx,15
     shr  bx,1
     shr  bx,1
     shr  bx,1
     shr  bx,1
     int  21h
     jnc  good_shrink
bad_mem:
     print error2
     stc
     ret
good_shrink:
; allocate 512 bytes for stack
     mov  ah,48h
     mov  bx,512/16
     int  21h
     jc   bad_mem
     pop  bx
     mov  ss,ax
     mov  sp,510
     push bx
     clc
     ret
open_file:
; opens the file for reading
     mov  ax,3d10h
     lea  dx,infile
     int  21h
     jnc  good_open
     print error1
     stc
     ret
good_open:
     mov  handle,ax
     ret
parse_line:
     mov  cl,byte ptr ds:[80h]
     mov  ch,0
     cmp  cx,2
     jge  ok_pcx
bad_pcx:
     print error1
     stc
     ret
ok_pcx:
; set up file
     mov  di,81h
     cld
     mov  al,20h
repe scasb
     je   bad_pcx
     cmp  cx,0
     jle  bad_pcx
     mov  si,di
     dec  si
      inc  cx
     lea  di,infile
pc_1:
     lodsb
     cmp   al,13
     je    pc_2
     cmp   al,20h
     je    pc_2
     stosb
     loop  pc_1
pc_2:
     clc
     ret
cseg ends
     end entry
